#include "dumpNand.h"
#include "3dstypes.h"
#include "libc.h"
#include "FS.h"
#include "draw.h"
#define BUFFER_ADDR ((volatile uint8_t*)0x21000000)
int BLOCK_SIZE=  (0x44111144);

uint32_t dumpSave(void)
{
	
	
	uint8_t fileHandle[32] = {0x00};
	uint8_t nandHandle[32] = {0x00};
	uint32_t bytesWritten;
	uint32_t bytesRead;
	uint32_t result;
	
	memset(&fileHandle, 0, 32);
	memset(&nandHandle, 0, 32);
	
	DEBUG("Opening sdmc:/save.nds.sav ...");
	result = fileOpen(&fileHandle, L"sdmc:/save.nds.sav", 6);
	if(result != 0)
		return 1;
	
	DEBUG("Opening cardspi:/ ...");
	result = fileOpen(&nandHandle, L"cardspi:/", 1);
	if(result != 0)
	{
		fileClose(&fileHandle);
		return 1;
	}
	
	DEBUG("Dumping SAVE...");
	
	uint32_t i = 0;

		fileRead(&nandHandle, &bytesRead, (void*)BUFFER_ADDR, BLOCK_SIZE);
		fileWrite(&fileHandle, &bytesWritten, (void*)BUFFER_ADDR, bytesRead);
		if(bytesWritten != bytesRead)
		{
			DEBUG("ERROR, SD card may be full.");
			fileClose(&nandHandle);
			fileClose(&fileHandle);
			return 1;
		}
		i += bytesRead;
		draw_fillrect(SCREEN_TOP_W-33, 1, 32, 8, BLACK);
		//font_draw_stringf(SCREEN_TOP_W-33, 1, CYAN, "%i%%", i/(988807168/100)); //988,807,168 bytes is how big my NAND is. Just used for the percentage indicator.

	
	draw_fillrect(SCREEN_TOP_W-33, 1, 32, 8, BLACK);
	DEBUG("Done!");
	
	fileClose(&nandHandle);
	fileClose(&fileHandle);
	return 0;
}

uint32_t writeSave(void)
{
	
	
	uint8_t fileHandle[32] = {0x00};
	uint8_t nandHandle[32] = {0x00};
	uint32_t bytesWritten;
	uint32_t bytesRead;
	uint32_t result;
	
	memset(&fileHandle, 0, 32);
	memset(&nandHandle, 0, 32);
	
	DEBUG("Opening sdmc:/save.nds.sav ...");
	result = fileOpen(&fileHandle, L"sdmc:/save.nds.sav", 1);
	if(result != 0)
		return 1;
	
	DEBUG("Opening cardspi:/ ...");
	result = fileOpen(&nandHandle, L"cardspi:/", 6);
	if(result != 0)
	{
		fileClose(&fileHandle);
		return 1;
	}
	
	DEBUG("Writing SAVE...");
	
	uint32_t i = 0;

		fileRead(&fileHandle, &bytesRead, (void*)BUFFER_ADDR, BLOCK_SIZE);
		fileWrite(&nandHandle, &bytesWritten, (void*)BUFFER_ADDR, bytesRead);
		if(bytesWritten != bytesRead)
		{
			DEBUG("ERROR, SD card may be full.");
			fileClose(&nandHandle);
			fileClose(&fileHandle);
			return 1;
		}
		i += bytesRead;
		draw_fillrect(SCREEN_TOP_W-33, 1, 32, 8, BLACK);
		//font_draw_stringf(SCREEN_TOP_W-33, 1, CYAN, "%i%%", i/(988807168/100)); //988,807,168 bytes is how big my NAND is. Just used for the percentage indicator.

	
	draw_fillrect(SCREEN_TOP_W-33, 1, 32, 8, BLACK);
	DEBUG("Done!");
	
	fileClose(&nandHandle);
	fileClose(&fileHandle);
	return 0;
}
